; Simple Blink in ASM
; Editing the work of Fiore Basile - FabAcademy 2014
; Public Domain

; the file tn44def.inc needs to be included within the same project folder
; I have tried to make sense of that file, but I honestly can not understand what goes on there
.include "tn44def.inc"

; ports are gates from the internal CPU to the external hardware/software
; the amount of ports depends on the type of microcontroller
; ports have a fixed address to establish communication with the CPU
.equ led_pin = PB2; led pin is PB2
.equ led_port = PORTB; comm port
.equ led_dir = DDRB; comm direction
.equ led_pins = PINB; comm pins
;
; registers are storages with 8-bits capacity. In AVR registers go from R0 to R31
; registers can be renamed, which is what happens in the next 6 lines
.def bitcnt = R16; bit counter
.def temp = R17; temporary storage
.def temp1 = R18; temporary storage
.def counter1 = R20;
.def counter2 = R22;
.def counter3 = R21;

; defining the variable delay
.equ delay_time = 20;


; CSEG and ORG are statements that I did not fully understand.
; However, I figured that the following three lines reset the interrupts handlers
.cseg
.org 0
rjmp reset


;
; main program
;
reset:
   ;
   ; set fuse low byte to 0x7E for 20 MHz resonator
   ; set clock divider to /1
   ; CLKPR is the clock prescale register, as described on the datasheet at page 31.
   ldi temp, (1 << CLKPCE)
   ldi temp1, (0 << CLKPS3) | (0 << CLKPS2) | (0 << CLKPS1) | (0 << CLKPS0)
   ; store register I/O location
   out CLKPR, temp
   out CLKPR, temp1

   ;
   ; set stack pointer to top of RAM
   ;
   ldi temp, high(RAMEND)
   out SPH, temp
   ldi temp, low(RAMEND)
   ; store register I/O location
   out SPL, temp


   ; clear Bit in I/O Register
   sbi led_port, led_pin
   sbi led_dir, led_pin

   ;
   ; start main loop
   ;
   loop:
       ; the SBI (Set Bit in I/O) instruction can be used to toggle one single bit in a port
       sbi led_pins, led_pin ; toggle led pin
       rcall delay
       ; the CBI (Clear Bit in I/O) instruction can be used to toggle one single bit in a port
       cbi led_pins, led_pin
       rcall delay
       rjmp loop

   ; loads the value in delay_time on register 21
   delay: ldi counter3, delay_time
   ;
   delay1: rcall counta
           dec counter3
           ; BRNE is branch if not equal
           brne delay1
           ; RET is retourn from subroutine
           ret
   ; loads the value 0 on register 20
   counta: ldi counter1, 0

   ; the fact that the function calls itself does not make sense to me, just like it happens later with pauseb
   pausea: rcall countb
           dec counter1
           brne pausea
           ret

   ; loads the value 0 on register 22
   countb: ldi counter2, 0

   pauseb: dec counter2
           brne pauseb
           ret
